﻿// information panel
var infopanel = (function(){
	var $moving =0; // 0:stop 1:up -1:down
	var $popuptoken = null; // popup animation token
	var $popuped=null; // flag if popup is completed
	var $popdown_timeout=null; // timeout to popdown

	var baseheight=70;
	var delta=11;
	var waku_show = function(){ //0 to 100
		var x=event.value;

		waku.y = view.height + waku_show._y[x];
		waku.opacity = waku_show._opacity[x];
		try{
			if(x==0){
				if(artist)artist.visible = false;
				$popuped=false;
				$moving =0;
			} else {
				if(artist)artist.visible = true;
				if(x==100){
					$popuped=true;
					$moving = 0;
				}
			}
		}catch(e){}
	}
	waku_show._opacity = new Array(100+1);
	waku_show._y = new Array(100+1);
	for(var i=0;i<=100;i++){
		waku_show._opacity[i] = 150+i*0.7;
		waku_show._y[i] = Math.cos(i*Math.PI/100)*(baseheight/2-delta) - (baseheight/2+delta);
	}

	var c={};
	c.popup=function(){
		if($moving == 1)return;
		if($popuptoken)view.cancelAnimation($popuptoken);
		if($popuped){
			$moving = 0;
			c.fix();
		}else{
			$popuptoken = view.beginAnimation(waku_show,1,100,500);
			$moving=1;
		}
	}
	c.popdown=function(force,later){
		if(later){
			$popdown_timeout=view.setTimeout(function(){c.popdown(force)},later);
			return;
		}
		try{
			if( (!isRunning()) || (iTunesApp==null) || (iTunesApp.PlayerState!=1) ){return;}
		}catch(e){
			return;
		}
		if($moving == -1)return;
		view.cancelAnimation($popuptoken);
		if($popuped || force){
			$popuptoken = view.beginAnimation(waku_show,99,0,500);
			$moving = -1;
		}else{
			$moving = 0;
			c.fix();
		}
		$popdown_timeout=null;
	}
	c.moving = function(){
		return (!!$moving);
	}
	c.popdown.cancel=function(){
		view.clearTimeout($popdown_timeout);
		$popdown_timeout=null;
	}
	c.fix = function(){ // waku_fix
		if($moving != 0)return;
		try{
			if($popuped){
				if(artist)artist.visible = true;
				waku.y  = view.height-baseheight;
			}else{
				if(artist)artist.visible = false;
				waku.y = view.height-delta*2;
			}
		}catch(e){}
	}
	return c;
})();
