﻿var iTunesApp = null;
var messengerApp = null;
//var darkgray = "#444444";
//var blue = "#0000FF";

var last = -1; // -1:(undefined) null:notplaying value:available_value
var last_image = "";
var state_old = -1;
var popuptime = 5000;

var image_toggler = false;
var image_current = null;

var wshShell;
var wshFSO;
var imgpath;
var default_messenger_tile = null;

function view_onOpen(){
//	pluginHelper.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);
	pluginHelper.onShowOptionsDlg = ShowOptionsDlg;
	SetDefaultOptions();
	updateWindowBorder();
	var temppath;
	try{
		wshShell = new ActiveXObject("WScript.Shell");
		wshFSO = framework.system.filesystem;
		temppath = wshShell.ExpandEnvironmentStrings("%TEMP%")+"\\gdietunes";
		if(!wshFSO.FolderExists(temppath)){
			wshFSO.CreateFolder(temppath);
		}
		imgpath = temppath + "\\_gdietunes";
		init_messengerApp();
	}catch(e){
		view.alert(e);
	}finally{
		clearGui();
		song.innerText = "";
		album.innerText = "";
		artist.innerText = "";

		if(isRunning() == true) runItunes();
		else askToRun();
		
		infopanel.popup();
	}
	return;
	
}
function init_messengerApp(){
	if(options.GetValue("sendimage_messenger")){
		try{
			messengerApp = new ActiveXObject('Messenger.UIAutomation.1');
			default_messenger_tile = messengerApp.MyProperty(2);
		}catch(e){}
	}
}

function isRunning(){
	var processlist = framework.system.process.enumerateProcesses;
	for(i = 0; i<processlist.Count; i++){

		var pid = processlist.Item(i);

		var procinfo = framework.system.process.getInfo(pid);
		var pathOfProc = procinfo.executablePath;
		
		var init = pathOfProc.indexOf("itunes.exe");
		if (init != -1){
			return true;
		}
	}
	return false;
}

// ask user to run iTunes when iTunes is not running.
function askToRun(){
	clearGui();
	if(isRunning()){
//		song.innerText = "iTunes is shutting down";
		song.innerText = "Disconnected by iTunes";
		infopanel.popup();
		if(connect() != true)
			view.setTimeout("askToRun()", 500);
		return;
	}

	song.innerText = "iTunes is not running.";
	infopanel.popup();
	golnk.visible = true;
	return;
}

function clearGui(){
	song.innerText = "";
	artist.innerText = "";
	album.innerText = "";
	golnk.visible = false;
	
	showart(null);
	
	playbtn.visible = false;
	prevbtn.visible = false;
	nextbtn.visible = false;
	rewindbtn.visible = false;
	fwdbtn.visible = false;
	itunesbtn.visible = false;
	playlistbtn.visible = false;

	last = -1;
	return;
}

function showMusicGui(){
	song.innerText = "";
	golnk.visible = false;
//	showart(null);
	
	playbtn.visible = true;
	prevbtn.visible = true;
	nextbtn.visible = true;
	rewindbtn.visible = true;
	fwdbtn.visible = true;
	itunesbtn.visible = true;
	playlistbtn.visible = true;
}

function runItunes(){
	song.innerText = "Starting iTunes ...";
	infopanel.popup();
	golnk.visible = false;
	try{
		wshShell.run("itunes");
		connecttoken = view.setTimeout("connect()", 1000);
	}catch(e){
		couldnotconnect();
	}
	return;
}


function connect(){
	if(isRunning() == false) {
		couldnotconnect();
		return;
	}
	try{
		//hangs system when itunes has to start up
		tryingtoconnect = true;
		iTunesApp = new ActiveXObject("iTunes.Application");
	}catch(e){
		couldnotconnect();
		return;
	}
	if(iTunesApp == null){
		couldnotconnect();
		return;
	}
	showMusicGui();
	update();
	updateloopid = view.setInterval("update()", 300);
	return true;
}

var updateloopid = null;

function couldnotconnect(){
		cancelUpdate();
		clearGui();
		song.innerText = "Could not connect to iTunes";
		golnk.visible = true;
		return;
}
function cancelUpdate(){
	if (updateloopid != null){
		view.clearInterval(updateloopid);
		updateloopid = null;
	}
}

function update(){
	if(infopanel.moving())return;
	try{
		if (iTunesApp == null){
			cancelUpdate();
			askToRun();
			return;
		}
		var curr;
		var state;
		try{
			curr = iTunesApp.CurrentTrack;
			state = iTunesApp.PlayerState;
		}catch(e){
			curr = null;
			state = state_old;
			if(!isRunning())throw(e); 
			return;
		}
		//new btns
		if(state_old != (state==1)){ // if state changed
			 if (state == 1) {
				playbtn.image = "stock_images\\pause_normal.png";
				playbtn.overImage = "stock_images\\pause_over.png";
				playbtn.downImage = "stock_images\\pause_normal.png";
//				if(popdown_timeout == null)popdown_timeout = view.setTimeout("popdown()",2000);
				infopanel.popdown(null,2000);
			 }else {
				playbtn.image = "stock_images\\play_normal.png";
				playbtn.overImage = "stock_images\\play_over.png";
				playbtn.downImage =  "stock_images\\play_normal.png";
				view.setTimeout(infopanel.popup,1000);
			}
			 if (state == 0) {
				fwdbtn.enabled = false;
				rewindbtn.enabled = false;
			 }else{
				fwdbtn.enabled = true;
				rewindbtn.enabled = true;
			}
		}
		state_old = (state==1);

		//new btns
		if(curr != null){
			if( (last == null) || (curr.name != last.name) || (curr.album != last.album) ) { // if track changed
				last=curr;
				pluginHelper.title=curr.name+" - GDieTunes";
				infopanel.popdown.cancel();
//				view.clearTimeout(popdown_timeout);
				view.setTimeout("infopanel.popup()",700);
				song.innerText = curr.Name;
				artist.innerText = curr.Artist;
				album.innerText = curr.Album;
//				popdown_timeout = view.setTimeout("popdown()",700+popuptime);
				infopanel.popdown(null,700+popuptime);
				if(state==1)
				showart(curr.Artwork.Item(1),true);
			}
		}else{
			if(last != null){
				pluginHelper.title="GDieTunes";
				song.innerText = "Push play to start";
				artist.innerText = "";
				album.innerText = "";
				playbtn.image = "stock_images\\play_normal.png";
				playbtn.overImage = "stock_images\\play_over.png";
				playbtn.downImage =  "stock_images\\play_normal.png";
				showart(null);
			}
		}
		last = curr;
		return; 
	}catch(e){
		cancelUpdate();
		itunesApp = null;
		askToRun();
	} 
}

function resize(nopopdown){
	var w = view.width;
	var h = view.height;

	if(contentarea.enabled){contentarea.height=h-backplayview.height-playlistfilter.height-5;}else{contentarea.height=0;}

	if(image_current){
		if(image_current.visible){
	//		image_current.setSrcSize(2*w,2*image_current.srcHeight*w/image_current.srcWidth); //?
			image_current.width=w;
			image_current.height=image_current.srcHeight*image_current.width/image_current.srcWidth;
			image_current.y=(h-image_current.height)/2;
		}
	}
	waku.width=w;
	song.width = w - 10;
	artist.width = w - 10;
	album.width = w - 10;
	infopanel.fix();
}

//shows art when artitem is not null
//hides art image when artitem is null.
function showart(artitem,f){
	var h = view.height;
	var w = view.width;
	var src = "";
	image_toggler=!image_toggler;
	image_current = (image_toggler?bg:fg);

	if(!f){ // ちょうださい
		src = "stock_images\\white.png";
		if(options.GetValue( "sendimage_messenger" ) && messengerApp){messengerApp.MyProperty(2) = default_messenger_tile;}
	}else if(artitem == null) {
		src = "stock_images\\no-art.jpg";
		if(options.GetValue( "sendimage_messenger" ) && messengerApp){messengerApp.MyProperty(2) = default_messenger_tile;}
	}else{
		artitem.SaveArtworkToFile(imgpath+image_toggler+".jpg");
		src = imgpath+image_toggler+".jpg";
		if(options.GetValue( "sendimage_messenger" ) && messengerApp){messengerApp.MyProperty(2) = src;}
	}
	if(last_image == src){
		image_toggler = !image_toggler;
		return;
	}else{
		image_current.src=src;
		if(image_toggler){
			view.beginAnimation(image_transit,255,0,500);
		}else{
			view.beginAnimation(image_transit,0,255,500);
		}
	}
	resize(true);
}

function image_transit(){
	fg.opacity = event.value;
	bg.opacity = 255-event.value;
}

function onpopout(){
	playlistSelector.show();
}
function onrestore(){
	playlistSelector.hide();
}

// ---- Options Dialog ----

function ShowOptionsDlg(wnd) {
	var check = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "sendimage_messenger", "Send AlbumArt to LiveMessenger",
		30, 25, 150, 22);
	check.value = options.GetValue("sendimage_messenger");

	var check = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "borderless_window", "Borderless window",
		30, 50, 150, 22);
	check.value = options.GetValue("borderless_window");

	wnd.onClose = OptionsDlgClosed;
}


function OptionsDlgClosed(wnd, code) {
	if (code == gddIdOK) {
		options.PutValue("sendimage_messenger", wnd.GetControl("sendimage_messenger").value);
		init_messengerApp();
		options.PutValue("borderless_window", wnd.GetControl("borderless_window").value);
		updateWindowBorder();
	}
}


function SetDefaultOptions() {
	options.defaultValue("sendimage_messenger") = false;
	options.defaultValue("borderless_window") = false;
}
function updateWindowBorder(){
	view.showCaptionAlways=!options.GetValue('borderless_window');
}

// 簡易文字列ふぉーまったー .Net Frameworkの複合書式設定とかJavaのMessageFormat風。 escape : { → {{    ,      } → }}
String.prototype.Format = function(){ //インスタンスメソッド
	var arg = arguments;
	return this.replace(/(\{\{)|(\{(\d+)\})|(\}\})/g,
		function(){
			switch(arguments[0]){
				case '{{': return '{';
				case '}}': return '}';
				default  : return ''+arg[arguments[3]];
			}
		}
	);
};
String.Format = function(formatstr){return String.prototype.Format.apply(formatstr,Array.prototype.splice.call(arguments,1))}
